using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using SubSystems.PD;             // WinPdf Converter

namespace Demo
{
	/// <summary>
 /// Summary description for demo.
	/// </summary>
 public class Demo : System.Windows.Forms.Form
	{
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.TextBox OutputFile;
     private System.Windows.Forms.Label Status;
     private System.Windows.Forms.GroupBox groupBox1;
     private System.Windows.Forms.Button OK;
     private System.Windows.Forms.Button Cancel;
     private System.Windows.Forms.LinkLabel Purchase;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

  ///////////////////////////////////////////////////////////////////////////////////////////////////
  ///    Constructor
  ///////////////////////////////////////////////////////////////////////////////////////////////////
  public Demo()
		{
    //
    // Required for Windows Form Designer support
    //
    InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label2 = new System.Windows.Forms.Label();
            this.OutputFile = new System.Windows.Forms.TextBox();
            this.Status = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.OK = new System.Windows.Forms.Button();
            this.Cancel = new System.Windows.Forms.Button();
            this.Purchase = new System.Windows.Forms.LinkLabel();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 24);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(192, 16);
            this.label2.TabIndex = 1;
            this.label2.Text = "Output File Name";
            // 
            // OutputFile
            // 
            this.OutputFile.Location = new System.Drawing.Point(8, 40);
            this.OutputFile.Name = "OutputFile";
            this.OutputFile.Size = new System.Drawing.Size(320, 20);
            this.OutputFile.TabIndex = 3;
            this.OutputFile.Text = "";
            // 
            // Status
            // 
            this.Status.Location = new System.Drawing.Point(208, 70);
            this.Status.Name = "Status";
            this.Status.Size = new System.Drawing.Size(120, 16);
            this.Status.TabIndex = 7;
            this.Status.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.OutputFile);
            this.groupBox1.Controls.Add(this.Status);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(336, 88);
            this.groupBox1.TabIndex = 8;
            this.groupBox1.TabStop = false;
            // 
            // OK
            // 
            this.OK.Location = new System.Drawing.Point(272, 104);
            this.OK.Name = "OK";
            this.OK.TabIndex = 9;
            this.OK.Text = "OK";
            this.OK.Click += new System.EventHandler(this.OK_Click);
            // 
            // Cancel
            // 
            this.Cancel.Location = new System.Drawing.Point(192, 104);
            this.Cancel.Name = "Cancel";
            this.Cancel.TabIndex = 10;
            this.Cancel.Text = "Cancel";
            // 
            // Purchase
            // 
            this.Purchase.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Purchase.LinkArea = new System.Windows.Forms.LinkArea(0, 0);
            this.Purchase.Location = new System.Drawing.Point(8, 104);
            this.Purchase.Name = "Purchase";
            this.Purchase.Size = new System.Drawing.Size(80, 16);
            this.Purchase.TabIndex = 11;
            this.Purchase.Text = "Purchase...";
            this.Purchase.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.Purchase_LinkClicked);
            // 
            // Demo
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(352, 141);
            this.Controls.Add(this.Purchase);
            this.Controls.Add(this.Cancel);
            this.Controls.Add(this.OK);
            this.Controls.Add(this.groupBox1);
            this.Name = "Demo";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "WinPdf Converter Demo";
            this.Load += new System.EventHandler(this.Demo_Load);
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion
 
  /// <summary>
  /// The main entry point for the application.
  /// </summary>
  [STAThread]
  static void Main() 
  {
   Application.Run(new Demo());
  }

  protected override void OnPaintBackground(System.Windows.Forms.PaintEventArgs ev)
  {
    base.OnPaintBackground(ev);
  }
  
     private void Demo_Load(object sender, System.EventArgs e) {
         Purchase.Links.Add(0,11, "www.subsystems.com/pdw.htm");
         OutputFile.Text="test.pdf";
     }

     private void OK_Click(object sender, System.EventArgs e) {
        Status.Text="";
        string OutFile=OutputFile.Text;
        bool UseDiskFile=false;

        // Create a metafile object containing example drawing functions
        Metafile metafile=null;
        //if (UseDiskFile)  metafile=(Metafile)Image.FromFile("dual.emf");
        if (UseDiskFile)  metafile=(Metafile)Image.FromFile("L:\\temp1\\test.wmf");
        //if (UseDiskFile)  metafile=(Metafile)Image.FromFile("l:\\temp1\\A01_Korea.wmf");
        else              metafile=CreatePageMetafile();

        // do the conversion
        Pdn pdf=new Pdn();

        // use the LicenseKey property to speicify your license key
        pdf.LicenseKey="";
        
        // Set document properties - you do not need to specify values for all these properties
        pdf.Author="Test Author";
        pdf.Title="Test Page";
        pdf.Producer="Sub Systems, Inc.";
        pdf.Subject="Creation of a sample PDF Page";
        pdf.Keywords="pdf,WinPdf,Sub,Systems";
        pdf.CreDate="07/02/2014";
        pdf.ModDate="07/02/2014";
        pdf.EmbedFonts=false;
        //pdf.CompressText=false;

        //pdf.PermFlags=pc.PERM_PRINT|pc.PERM_MOD|pc.PERM_COPY;    // security and password variables
        //pdf.OwnerPassword="abc";
        //pdf.UserPassword="efg";
        //pdf.RC4_128=true;    // enable RC4 128 bit encryption when password is set
        //pdf.PdfACompliant=true;

        //pdf.PdfA3Compliant=true;
        //pdf.PdcEmbedFile("ZUGFeRD.xml",null,"ZUGFeRD");  // example of embedding an external file in pdf
        //pdf.PdcEmbedFile("test.xml",null,"test xml file");  // example of embedding an external file in pdf
        //pdf.PdcEmbedFile2("new.pdf",null,"test pdf file","application/pdf");  // example of embedding an external file in pdf
        //pdf.PdcEmbedFile("test.png",null,"test png file");  // example of embedding an external file in pdf


        // Start document creation
        pdf.PdcStartDoc(OutFile);       // start the pdf engine
        
        pdf.PdcStartPage((int)(8.5*1440),(int)(11*1440));     // start a new page, assume 8.5 x 11 size paper
        //pdf.PdcStartPage((int)(11*1440),(int)(14*1440));     // start a new page, assume 8.5 x 11 size paper
        
        if (UseDiskFile) pdf.PdcDrawMetafile(metafile,(int)metafile.HorizontalResolution,(int)metafile.VerticalResolution);   // use the 
        else             pdf.PdcDrawMetafile(metafile,300,300);   // CreatePageMetafile creates pages in 1/300 inches resolution
        
        pdf.PdcEndPage();
      
        pdf.PdcEndDoc();   // close the pdf file

        metafile.Dispose();

        OutputFile.Focus();    // ask for the next file
        Status.Text="Done!";
        System.Diagnostics.Process.Start(OutFile);

     }

     private void Purchase_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs ev) {
        // Determine which link was clicked within the LinkLabel.
        Purchase.Links[Purchase.Links.IndexOf(ev.Link)].Visited = true;
        // Display the appropriate link based on the value of the LinkData property of the Link object.
        System.Diagnostics.Process.Start(ev.Link.LinkData.ToString());
     }
  
     //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     //////  Helper functions
     /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     /******************************************************************************
         CreatePageMetafile:
         Return a page in a metafile
     ******************************************************************************/
     internal new Metafile CreatePageMetafile()
     {
         int UnitsPerInch=300;    // MetafileFrameUnit.Document - assume metafile resolution of 300

         // set the page rectangle
         Rectangle PageRect=new Rectangle();

         PageRect.X=PageRect.Y=0;
         PageRect.Width=(int)(8.50*UnitsPerInch);  // assume 8.5 x 11 paper
         PageRect.Height=(int)(11*UnitsPerInch); 

         IntPtr hRefDC=Win32.GetDC((IntPtr)null);
         Metafile mf= new Metafile(hRefDC,PageRect, 
                                           MetafileFrameUnit.Document,    // 1/300 of an inch
                                           EmfType.EmfOnly);

         Graphics gr = Graphics.FromImage(mf);

         gr.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;            // 20150415: set to high quality to preserve all pixels
         gr.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
         gr.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
         gr.PixelOffsetMode = PixelOffsetMode.HighQuality;

         DrawPage(gr);

         gr.Dispose();


         Win32.ReleaseDC((IntPtr)null,hRefDC);

         return mf;
     }

     /******************************************************************************
         DrawPage:
         Construt a sample page using .NET Graphics methods.
         The metafile resolution is 300.
     ******************************************************************************/
     internal new void DrawPage(Graphics gr)
     {
        string pText;
        PointF pt;

        // create fonts used for creating the page
        Font BigFont=new Font("Times New Roman",14*300/72,FontStyle.Regular);  // 14 points = 14*300/72 metafile units
        Font MedFont=new Font("Times New Roman",12*300/72,FontStyle.Regular);  
        Font MedBoldFont=new Font("Times New Roman",12*300/72,FontStyle.Bold);  
        Font SmallFont=new Font("Times New Roman",10*300/72,FontStyle.Regular);  

        // write title text
        pText="S T A T E M E N T";
        pt=new PointF(MetaUnit(3.25),MetaUnit(1.0));  // point to draw the string
        gr.DrawString(pText,BigFont,Brushes.Red,pt);
      
        // Write customer name between two horizontal lines
        gr.DrawLine(Pens.Black,MetaUnit(1.35),MetaUnit(2.0),MetaUnit(7.20),MetaUnit(2.0));

        pText="Customer Name: ";
        pt=new PointF(MetaUnit(1.35),MetaUnit(2.0));  // point to draw the string
        gr.DrawString(pText,MedFont,Brushes.Blue,pt);

        
        pText="Affront Dog Collars";
        pt=new PointF(MetaUnit(3.0),MetaUnit(2.0));  // point to draw the string
        gr.DrawString(pText,MedBoldFont,Brushes.Blue,pt);

        gr.DrawLine(Pens.Black,MetaUnit(1.35),MetaUnit(2.30),MetaUnit(7.20),MetaUnit(2.30));

        // Write balance figures

        pText="Previous Balance: $2000.00";
        pt=new PointF(MetaUnit(4.75),MetaUnit(3.45));  // point to draw the string
        gr.DrawString(pText,MedFont,Brushes.Black,pt);


        pText="Current Balance:  $1000.00";
        pt=new PointF(MetaUnit(4.81),MetaUnit(3.80));  // point to draw the string
        gr.DrawString(pText,MedFont,Brushes.Black,pt);

        gr.DrawLine(Pens.Black,MetaUnit(6.50),MetaUnit(4.2),MetaUnit(7.30),MetaUnit(4.2));

        
        pText="Due:  $3000.00";
        pt=new PointF(MetaUnit(5.86),MetaUnit(4.20));  // point to draw the string
        gr.DrawString(pText,MedBoldFont,Brushes.Black,pt);


        gr.DrawLine(Pens.Black,MetaUnit(6.50),MetaUnit(4.51),MetaUnit(7.30),MetaUnit(4.51));
        gr.DrawLine(Pens.Black,MetaUnit(6.50),MetaUnit(4.53),MetaUnit(7.30),MetaUnit(4.53));

        gr.DrawLine(Pens.Black,MetaUnit(4.86),MetaUnit(4.86),MetaUnit(7.30),MetaUnit(4.86));

        // write some page footer text
        gr.DrawLine(Pens.Black,MetaUnit(1.35),MetaUnit(9.7),MetaUnit(7.20),MetaUnit(9.7));

        pText="Sub Systems, Inc.";
        pt=new PointF(MetaUnit(3.6),MetaUnit(9.7));  // point to draw the string
        gr.DrawString(pText,SmallFont,Brushes.Green,pt);

        pText="3017 Covington Place, Round Rock, TX 78681";
        pt=new PointF(MetaUnit(2.50),MetaUnit(9.86));  // point to draw the string
        gr.DrawString(pText,SmallFont,Brushes.Green,pt);
        
        //PrintSignature(gr,BigFont,4000,8000);  // an example of printing a signature, x/y are passed as twips

        // dispose the resources
        BigFont.Dispose();
        MedFont.Dispose();
        MedBoldFont.Dispose();
     }
     
     /******************************************************************************
         PrintSignature:
         An example of adding signature  (for future use)
     ******************************************************************************/
     bool PrintSignature(Graphics gr,Font font, int x, int y)
     {
         pc.StrPdfField fld=new pc.StrPdfField();
         string pText;
         PointF pt;

         // start signature block
         fld.init();

         fld.sign[0]=(byte)'F';
         fld.sign[1]=(byte)'L';  
         fld.begin=true;
         fld.page=0;   
         fld.x=x/20;   // pass in point units
         fld.y=y/20;   // pass in point units 
         fld.width=72*3;   // pass in point units
         fld.height=72*1 ;   // pass in point units 
         fld.type=pc.PDFFIELD_SIGNATURE;
         fld.CertName="Sub Systems, Inc.";     // certificate name
         fld.DateTime="D:20130710085500-05'00'";     // date/time in D:YYYYMMDDhhmmss-hh'mm' format where the last -hh'mm' is +- from gmt time
         gr.AddMetafileComment(fld.ToByteArray());

    
         // write signature text
         pText="Signed: my signature";
         x+=1440/4;
         y+=1440/4;
         pt=new PointF(MetaUnit((double)x/1440),MetaUnit((double)y/1440));  // point to draw the string
         gr.DrawString(pText,font,Brushes.Red,pt);

         pText="Date: 7/10/2013";
         y+=1440/3;

         pt=new PointF(MetaUnit((double)x/1440),MetaUnit((double)y/1440));  // point to draw the string
         gr.DrawString(pText,font,Brushes.Red,pt);

 
         // end signature block
         fld.init();

         fld.sign[0]=(byte)'F';
         fld.sign[1]=(byte)'L';  
         fld.begin=false;
         gr.AddMetafileComment(fld.ToByteArray());
 
         return true;
     }

     /******************************************************************************
         MetaUnit:
         Convert inches to metafile unit.
         The metafile resolution is 300.
     ******************************************************************************/
      
     internal new int MetaUnit(double x)
     {
        return (int)(x*300);
     }  

     string ReadFromFile(string file) 
     {
        string str=null;

        StreamReader InFile=null;
        if ((InFile=new StreamReader(file))!=null) {
          str=InFile.ReadToEnd();
          InFile.Close();
        }

        return str;
     } 
 
     bool WriteToFile(string file, string OutData) 
     {
        bool result=false;

        StreamWriter OutFile=null;
        try {
          if ((OutFile=new StreamWriter(file))!=null) {
            OutFile.Write(OutData);
            OutFile.Close();
            result=true;
          }
        }
        catch (Exception) {
        } 


        return result;
     } 
     /////////////////////////////////////////////////////////////////////////////////////////////////////////////
     //    Testing/Debugging code                                                                    
     /////////////////////////////////////////////////////////////////////////////////////////////////////////////
     /***************************************************************************
         ToInt:
         Convert string to integer
     ****************************************************************************/
     internal new int ToInt(TextBox item)
     {
        return ToInt(item.Text);
     }

     internal new int ToInt(string txt)
     {
        try {
           return (int)Convert.ToInt32(txt);
        } 
        catch (System.Exception)
        {
           return 0;
        }
     } 

     internal new bool True(int val)
     {
        return (val!=0);
     }


 }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 /// Interop class
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  internal class Win32
  {
      [DllImport("user32.dll",CharSet=CharSet.Unicode)]
      internal static extern IntPtr GetDC(IntPtr hWnd);
      [DllImport("user32.dll",CharSet=CharSet.Unicode)]
      internal static extern int ReleaseDC(IntPtr hWnd, IntPtr hDC);
  }
}
